window.Gleam.initSearch([{"doc":"glv8","title":"glv8","content":"# glv8\n\nglv8 facilitates one to write [gleam](https://gleam.run) for postgresql as trusted language extension.\nIt provides [plv8](https://plv8.github.io) bindings and tools like [plv8ify](https://github.com/divyenduz/plv8ify)\n\n[![Package Version](https://img.shields.io/hexpm/v/glv8)](https://hex.pm/packages/glv8)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/glv8/)\n\nglv8 is *not* a SQL query builder, it is not an application framework either. Instead it promotes\ngleam as an alternative to JavaScript to do functional computation in a restricted JavaScript runtime,\ndirectly inside postgresql database.\n\nFurther documentation can be found at &lt;https://hexdocs.pm/glv8&gt;.\n\n## Development\n\n```sh\ngleam build # Run the project\ngleam test  # Run the tests\n```\n","url":"index.html"},{"doc":"glv8","title":"DBError","content":"pub type DBError {\n  DBError(Nil)\n  DBErrorMessage(e: String)\n  DBErrorJson(j: Json)\n  DBErrorDecode(es: DecodeErrors)\n}\n\nDBError(Nil)\n\n\nDBErrorMessage(e: String)\n\n\nDBErrorJson(j: Json)\n\n\nDBErrorDecode(es: DecodeErrors)\n\n\nSynonyms:\nglv8.DBError\nglv8 DBError","url":"glv8.html#DBError"},{"doc":"glv8","title":"Function0","content":"pub type Function0 =\n  fn() -&gt; Nil\n\n\nSynonyms:\nglv8.Function0\nglv8 Function0","url":"glv8.html#Function0"},{"doc":"glv8","title":"Function1","content":"pub type Function1(a) =\n  fn(a) -&gt; Nil\n\n\nSynonyms:\nglv8.Function1\nglv8 Function1","url":"glv8.html#Function1"},{"doc":"glv8","title":"Function2","content":"pub type Function2(a, b) =\n  fn(a, b) -&gt; Nil\n\n\nSynonyms:\nglv8.Function2\nglv8 Function2","url":"glv8.html#Function2"},{"doc":"glv8","title":"Function3","content":"pub type Function3(a, b, c) =\n  fn(a, b, c) -&gt; Nil\n\n\nSynonyms:\nglv8.Function3\nglv8 Function3","url":"glv8.html#Function3"},{"doc":"glv8","title":"Function4","content":"pub type Function4(a, b, c, d) =\n  fn(a, b, c, d) -&gt; Nil\n\n\nSynonyms:\nglv8.Function4\nglv8 Function4","url":"glv8.html#Function4"},{"doc":"glv8","title":"glv8","content":"","url":"glv8.html"},{"doc":"glv8/database","title":"Cursor","content":"pub type Cursor\n\n\nSynonyms:\nglv8/database.Cursor\nglv8/database Cursor","url":"glv8/database.html#Cursor"},{"doc":"glv8/database","title":"PreparedPlan","content":"pub type PreparedPlan\n\n\nSynonyms:\nglv8/database.PreparedPlan\nglv8/database PreparedPlan","url":"glv8/database.html#PreparedPlan"},{"doc":"glv8/database","title":"Row","content":"pub type Row {\n  Row\n  NilRow(Nil)\n}\n\nRow\n\n\nNilRow(Nil)\n\n\nSynonyms:\nglv8/database.Row\nglv8/database Row","url":"glv8/database.html#Row"},{"doc":"glv8/database","title":"SubTransaction","content":"pub type SubTransaction =\n  fn() -&gt; Nil\n\n\nSynonyms:\nglv8/database.SubTransaction\nglv8/database SubTransaction","url":"glv8/database.html#SubTransaction"},{"doc":"glv8/database","title":"cursor_close","content":"pub fn cursor_close(cursor c: Cursor) -&gt; Nil\n\n\n\nSynonyms:\nglv8/database.cursor_close\nglv8/database cursor_close","url":"glv8/database.html#cursor_close"},{"doc":"glv8/database","title":"cursor_fetch","content":"pub fn cursor_fetch(cursor c: Cursor) -&gt; Result(Row, DBError)\n\n\n\nSynonyms:\nglv8/database.cursor_fetch\nglv8/database cursor_fetch","url":"glv8/database.html#cursor_fetch"},{"doc":"glv8/database","title":"cursor_fetch_as","content":"pub fn cursor_fetch_as(\n  cursor c: Cursor,\n  of f: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n) -&gt; Result(a, DBError)\n\n\n\nSynonyms:\nglv8/database.cursor_fetch_as\nglv8/database cursor_fetch_as","url":"glv8/database.html#cursor_fetch_as"},{"doc":"glv8/database","title":"cursor_fetch_rows","content":"pub fn cursor_fetch_rows(\n  cursor c: Cursor,\n  rows n: Int,\n) -&gt; Result(Array(Row), DBError)\n\n\n\nSynonyms:\nglv8/database.cursor_fetch_rows\nglv8/database cursor_fetch_rows","url":"glv8/database.html#cursor_fetch_rows"},{"doc":"glv8/database","title":"cursor_fetch_rows_as","content":"pub fn cursor_fetch_rows_as(\n  cursor c: Cursor,\n  rows n: Int,\n  of f: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n) -&gt; Result(Array(a), DBError)\n\n\n\nSynonyms:\nglv8/database.cursor_fetch_rows_as\nglv8/database cursor_fetch_rows_as","url":"glv8/database.html#cursor_fetch_rows_as"},{"doc":"glv8/database","title":"cursor_move","content":"pub fn cursor_move(cursor c: Cursor, rows n: Int) -&gt; Nil\n\n\n\nSynonyms:\nglv8/database.cursor_move\nglv8/database cursor_move","url":"glv8/database.html#cursor_move"},{"doc":"glv8/database","title":"decode","content":"pub fn decode(\n  rows rs: Array(Row),\n  decoder f: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n) -&gt; Result(Array(a), DBError)\n\n\n\nSynonyms:\nglv8/database.decode\nglv8/database decode","url":"glv8/database.html#decode"},{"doc":"glv8/database","title":"decode0","content":"pub fn decode0(\n  row r: Row,\n  decoder f: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n) -&gt; Result(a, DBError)\n\n\n\nSynonyms:\nglv8/database.decode0\nglv8/database decode0","url":"glv8/database.html#decode0"},{"doc":"glv8/database","title":"execute","content":"pub fn execute(\n  query q: String,\n  parameters p: a,\n) -&gt; Result(Array(Row), DBError)\n\n\n\nSynonyms:\nglv8/database.execute\nglv8/database execute","url":"glv8/database.html#execute"},{"doc":"glv8/database","title":"execute0","content":"pub fn execute0(\n  query q: String,\n  parameters p: a,\n) -&gt; Result(Int, DBError)\n\n\n\nSynonyms:\nglv8/database.execute0\nglv8/database execute0","url":"glv8/database.html#execute0"},{"doc":"glv8/database","title":"execute_as","content":"pub fn execute_as(\n  query q: String,\n  parameters p: a,\n  of f: fn(Dynamic) -&gt; Result(b, List(DecodeError)),\n) -&gt; Result(Array(b), DBError)\n\n\n\nSynonyms:\nglv8/database.execute_as\nglv8/database execute_as","url":"glv8/database.html#execute_as"},{"doc":"glv8/database","title":"plan_cursor","content":"pub fn plan_cursor(\n  plan pl: PreparedPlan,\n  parameters p: a,\n) -&gt; Cursor\n\n\n\nSynonyms:\nglv8/database.plan_cursor\nglv8/database plan_cursor","url":"glv8/database.html#plan_cursor"},{"doc":"glv8/database","title":"plan_execute","content":"pub fn plan_execute(\n  plan pl: PreparedPlan,\n  parameters p: a,\n) -&gt; Result(Array(Row), DBError)\n\n\n\nSynonyms:\nglv8/database.plan_execute\nglv8/database plan_execute","url":"glv8/database.html#plan_execute"},{"doc":"glv8/database","title":"plan_execute_as","content":"pub fn plan_execute_as(\n  plan pl: PreparedPlan,\n  parameters p: a,\n  of f: fn(Dynamic) -&gt; Result(b, List(DecodeError)),\n) -&gt; Result(Array(b), DBError)\n\n\n\nSynonyms:\nglv8/database.plan_execute_as\nglv8/database plan_execute_as","url":"glv8/database.html#plan_execute_as"},{"doc":"glv8/database","title":"plan_free","content":"pub fn plan_free(plan pl: PreparedPlan) -&gt; Nil\n\n\n\nSynonyms:\nglv8/database.plan_free\nglv8/database plan_free","url":"glv8/database.html#plan_free"},{"doc":"glv8/database","title":"prepare","content":"pub fn prepare(\n  query q: String,\n  paremeters p: Array(String),\n) -&gt; PreparedPlan\n\n\n\nSynonyms:\nglv8/database.prepare\nglv8/database prepare","url":"glv8/database.html#prepare"},{"doc":"glv8/database","title":"subtransaction","content":"pub fn subtransaction(\n  transaction t: fn() -&gt; Nil,\n) -&gt; Result(Nil, DBError)\n\n\n\nSynonyms:\nglv8/database.subtransaction\nglv8/database subtransaction","url":"glv8/database.html#subtransaction"},{"doc":"glv8/database","title":"glv8/database","content":"","url":"glv8/database.html"},{"doc":"glv8/util","title":"elog","content":"pub fn elog(level l: Symbol, message m: String) -&gt; Nil\n\n\n\nSynonyms:\nglv8/util.elog\nglv8/util elog","url":"glv8/util.html#elog"},{"doc":"glv8/util","title":"elog_debug1","content":"pub fn elog_debug1(message m: String) -&gt; Nil\n\n\n\nSynonyms:\nglv8/util.elog_debug1\nglv8/util elog_debug1","url":"glv8/util.html#elog_debug1"},{"doc":"glv8/util","title":"elog_debug2","content":"pub fn elog_debug2(message m: String) -&gt; Nil\n\n\n\nSynonyms:\nglv8/util.elog_debug2\nglv8/util elog_debug2","url":"glv8/util.html#elog_debug2"},{"doc":"glv8/util","title":"elog_debug3","content":"pub fn elog_debug3(message m: String) -&gt; Nil\n\n\n\nSynonyms:\nglv8/util.elog_debug3\nglv8/util elog_debug3","url":"glv8/util.html#elog_debug3"},{"doc":"glv8/util","title":"elog_debug4","content":"pub fn elog_debug4(message m: String) -&gt; Nil\n\n\n\nSynonyms:\nglv8/util.elog_debug4\nglv8/util elog_debug4","url":"glv8/util.html#elog_debug4"},{"doc":"glv8/util","title":"elog_debug5","content":"pub fn elog_debug5(message m: String) -&gt; Nil\n\n\n\nSynonyms:\nglv8/util.elog_debug5\nglv8/util elog_debug5","url":"glv8/util.html#elog_debug5"},{"doc":"glv8/util","title":"elog_error","content":"pub fn elog_error(message m: String) -&gt; Nil\n\n\n\nSynonyms:\nglv8/util.elog_error\nglv8/util elog_error","url":"glv8/util.html#elog_error"},{"doc":"glv8/util","title":"elog_info","content":"pub fn elog_info(message m: String) -&gt; Nil\n\n\n\nSynonyms:\nglv8/util.elog_info\nglv8/util elog_info","url":"glv8/util.html#elog_info"},{"doc":"glv8/util","title":"elog_log","content":"pub fn elog_log(message m: String) -&gt; Nil\n\n\n\nSynonyms:\nglv8/util.elog_log\nglv8/util elog_log","url":"glv8/util.html#elog_log"},{"doc":"glv8/util","title":"elog_notice","content":"pub fn elog_notice(message m: String) -&gt; Nil\n\n\n\nSynonyms:\nglv8/util.elog_notice\nglv8/util elog_notice","url":"glv8/util.html#elog_notice"},{"doc":"glv8/util","title":"elog_warning","content":"pub fn elog_warning(message m: String) -&gt; Nil\n\n\n\nSynonyms:\nglv8/util.elog_warning\nglv8/util elog_warning","url":"glv8/util.html#elog_warning"},{"doc":"glv8/util","title":"find_function0","content":"pub fn find_function0(function f: String) -&gt; fn() -&gt; Nil\n\n\n\nSynonyms:\nglv8/util.find_function0\nglv8/util find_function0","url":"glv8/util.html#find_function0"},{"doc":"glv8/util","title":"find_function1","content":"pub fn find_function1(function f: String) -&gt; fn(a) -&gt; Nil\n\n\n\nSynonyms:\nglv8/util.find_function1\nglv8/util find_function1","url":"glv8/util.html#find_function1"},{"doc":"glv8/util","title":"find_function2","content":"pub fn find_function2(function f: String) -&gt; fn(a, b) -&gt; Nil\n\n\n\nSynonyms:\nglv8/util.find_function2\nglv8/util find_function2","url":"glv8/util.html#find_function2"},{"doc":"glv8/util","title":"find_function3","content":"pub fn find_function3(function f: String) -&gt; fn(a, b, c) -&gt; Nil\n\n\n\nSynonyms:\nglv8/util.find_function3\nglv8/util find_function3","url":"glv8/util.html#find_function3"},{"doc":"glv8/util","title":"find_function4","content":"pub fn find_function4(\n  function f: String,\n) -&gt; fn(a, b, c, d) -&gt; Nil\n\n\n\nSynonyms:\nglv8/util.find_function4\nglv8/util find_function4","url":"glv8/util.html#find_function4"},{"doc":"glv8/util","title":"info","content":"pub fn info() -&gt; Json\n\n\n\nSynonyms:\nglv8/util.info\nglv8/util info","url":"glv8/util.html#info"},{"doc":"glv8/util","title":"memory_usage","content":"pub fn memory_usage() -&gt; Json\n\n\n\nSynonyms:\nglv8/util.memory_usage\nglv8/util memory_usage","url":"glv8/util.html#memory_usage"},{"doc":"glv8/util","title":"reset","content":"pub fn reset(context ctx: String) -&gt; Nil\n\n\n\nSynonyms:\nglv8/util.reset\nglv8/util reset","url":"glv8/util.html#reset"},{"doc":"glv8/util","title":"reset_all","content":"pub fn reset_all() -&gt; Nil\n\n\n\nSynonyms:\nglv8/util.reset_all\nglv8/util reset_all","url":"glv8/util.html#reset_all"},{"doc":"glv8/util","title":"run_script","content":"pub fn run_script(scritp s: String, file f: String) -&gt; Nil\n\n\n\nSynonyms:\nglv8/util.run_script\nglv8/util run_script","url":"glv8/util.html#run_script"},{"doc":"glv8/util","title":"version","content":"pub fn version() -&gt; String\n\n\n\nSynonyms:\nglv8/util.version\nglv8/util version","url":"glv8/util.html#version"},{"doc":"glv8/util","title":"glv8/util","content":"","url":"glv8/util.html"},{"doc":"glv8/window","title":"WindowObject","content":"pub type WindowObject\n\n\nSynonyms:\nglv8/window.WindowObject\nglv8/window WindowObject","url":"glv8/window.html#WindowObject"},{"doc":"glv8/window","title":"get_window_object","content":"pub fn get_window_object() -&gt; WindowObject\n\n\n\nSynonyms:\nglv8/window.get_window_object\nglv8/window get_window_object","url":"glv8/window.html#get_window_object"},{"doc":"glv8/window","title":"glv8/window","content":"","url":"glv8/window.html"}]);